(*
 * F-ing Modules with Coq
 *
 * (c) 2009 Andreas Rossberg & Claudio Russo
 *)

Require Import Fomega.


Definition Id : Set := nat.

Definition Knd : Set := knd.

Inductive Typ : Set :=
  | TypT : typ -> Typ
  | PathT : Path -> Typ (* P*)
  | PackT : Sig -> Typ (* pack S *)

with Exp : Set :=
  | ExpE : exp -> Exp
  | PathE : Path -> Exp (* P *)
  | PackE : Id -> Sig -> Exp (* pack X:S *)

with Sig : Set :=
  | PathS : Path -> Sig (* P *)
  | StrS : Dec -> Sig  (* {D} *)
  | FunS : Id -> Sig -> Sig -> Sig (* (X:S)->S *)
(*| FunPureS : Id -> Sig -> Sig -> Sig (* (X:S)=>S *)*)
(*| ValEqS : Sig  -> list Id -> Path -> Sig (* S where value Xs=P *)*)
  | TypEqS : Sig  -> list Id -> Typ -> Sig (* S where type Xs=T *)
(*| ModEqS : Sig  -> list Id -> Path -> Sig (* S where module Xs=P *)*)

with Dec : Set :=
  | ValD : Id -> Typ -> Dec (* value X:T *)
(*| ValEqD : Id -> Path -> Dec (* value X=P *)*)
  | TypD : Id -> Knd -> Dec (* type X:K *)
  | TypEqD : Id -> Typ -> Dec (* type X=T *)
  | ModD : Id -> Sig -> Dec (* module X:S *)
(*| ModEqD : Id -> Path -> Dec (* module X=P *)*)
  | SigEqD : Id -> Sig -> Dec (* signature X=S *)
  | EmpD : Dec (* epsilon *)
  | SeqD : Dec -> Dec -> Dec (* D;D *)
  | InclD : Sig -> Dec (* include S *)

with Mod : Set :=
  | IdM : Id -> Mod (* X *)
  | StrM : Bind -> Mod (* {B} *)
  | DotM : Mod -> Id -> Mod (* M.X *)
  | FunM :  Id -> Sig -> Mod -> Mod (* fun X:S->M *)
  | AppM : Id -> Id -> Mod (* X X *)
  | SealM : Id -> Sig -> Mod (* X:>S *)
  | UnpackM : Exp -> Sig -> Mod (* unpack E:S *)

with Bind : Set :=
  | ValB : Id -> Exp -> Bind (* value=E *)
  | TypB : Id -> Typ -> Bind (* type=T *)
  | ModB : Id -> Mod -> Bind (* module X=M *)
  | SigB : Id -> Sig -> Bind (* signature X=S *)
  | EmpB : Bind (* epsilon *)
  | SeqB : Bind -> Bind -> Bind (* B;B *)
  | InclB : Mod -> Bind (* include M *)

with Path : Set :=
  | ModP : Mod -> Path (* M *)
.
